// Code generated by protoc-gen-go. DO NOT EDIT.
// source: api/protobuf-spec/frontend.proto

package pb

import proto "github.com/golang/protobuf/proto"
import fmt "fmt"
import math "math"

import (
	context "golang.org/x/net/context"
	grpc "google.golang.org/grpc"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// Reference imports to suppress errors if they are not otherwise used.
var _ context.Context
var _ grpc.ClientConn

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
const _ = grpc.SupportPackageIsVersion4

// Client API for Frontend service

type FrontendClient interface {
	// CreatePlayer will put the player  in state storage, and then look
	// through the 'properties' field for the attributes you have defined as
	// indices your matchmaker config.  If the attributes exist and are valid
	// integers, they will be indexed.
	// INPUT: Player message with these fields populated:
	//  - id
	//  - properties
	// OUTPUT: Result message denoting success or failure (and an error if
	// necessary)
	CreatePlayer(ctx context.Context, in *Player, opts ...grpc.CallOption) (*Result, error)
	// DeletePlayer removes the player from state storage by doing the
	// following:
	//  1) Delete player from configured indices.  This effectively removes the
	//     player from matchmaking when using recommended MMF patterns.
	//     Everything after this is just cleanup to save stage storage space.
	//  2) 'Lazily' delete the player's state storage record.  This is kicked
	//     off in the background and may take some time to complete.
	//  2) 'Lazily' delete the player's metadata indicies (like, the timestamp when
	//     they called CreatePlayer, and the last time the record was accessed).  This
	//     is also kicked off in the background and may take some time to complete.
	// INPUT: Player message with the 'id' field populated.
	// OUTPUT: Result message denoting success or failure (and an error if
	// necessary)
	DeletePlayer(ctx context.Context, in *Player, opts ...grpc.CallOption) (*Result, error)
	// GetUpdates streams matchmaking results from Open Match for the
	// provided player ID.
	// INPUT: Player message with the 'id' field populated.
	// OUTPUT: a stream of player objects with one or more of the following
	// fields populated, if an update to that field is seen in state storage:
	//  - 'assignment': string that usually contains game server connection information.
	//  - 'status': string to communicate current matchmaking status to the client.
	//  - 'error': string to pass along error information to the client.
	//
	// During normal operation, the expectation is that the 'assignment' field
	// will be updated by a Backend process calling the 'CreateAssignments' Backend API
	// endpoint.  'Status' and 'Error' are free for developers to use as they see fit.
	// Even if you had multiple players enter a matchmaking request as a group, the
	// Backend API 'CreateAssignments' call will write the results to state
	// storage separately under each player's ID. OM expects you to make all game
	// clients 'GetUpdates' with their own ID from the Frontend API to get
	// their results.
	//
	// NOTE: This call generates a small amount of load on the Frontend API and state
	//  storage while watching the player record for updates. You are expected
	//  to close the stream from your client after receiving your matchmaking
	//  results (or a reasonable timeout), or you will continue to
	//  generate load on OM until you do!
	// NOTE: Just bear in mind that every update will send egress traffic from
	//  Open Match to game clients! Frugality is recommended.
	GetUpdates(ctx context.Context, in *Player, opts ...grpc.CallOption) (Frontend_GetUpdatesClient, error)
}

type frontendClient struct {
	cc *grpc.ClientConn
}

func NewFrontendClient(cc *grpc.ClientConn) FrontendClient {
	return &frontendClient{cc}
}

func (c *frontendClient) CreatePlayer(ctx context.Context, in *Player, opts ...grpc.CallOption) (*Result, error) {
	out := new(Result)
	err := grpc.Invoke(ctx, "/api.Frontend/CreatePlayer", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *frontendClient) DeletePlayer(ctx context.Context, in *Player, opts ...grpc.CallOption) (*Result, error) {
	out := new(Result)
	err := grpc.Invoke(ctx, "/api.Frontend/DeletePlayer", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *frontendClient) GetUpdates(ctx context.Context, in *Player, opts ...grpc.CallOption) (Frontend_GetUpdatesClient, error) {
	stream, err := grpc.NewClientStream(ctx, &_Frontend_serviceDesc.Streams[0], c.cc, "/api.Frontend/GetUpdates", opts...)
	if err != nil {
		return nil, err
	}
	x := &frontendGetUpdatesClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Frontend_GetUpdatesClient interface {
	Recv() (*Player, error)
	grpc.ClientStream
}

type frontendGetUpdatesClient struct {
	grpc.ClientStream
}

func (x *frontendGetUpdatesClient) Recv() (*Player, error) {
	m := new(Player)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// Server API for Frontend service

type FrontendServer interface {
	// CreatePlayer will put the player  in state storage, and then look
	// through the 'properties' field for the attributes you have defined as
	// indices your matchmaker config.  If the attributes exist and are valid
	// integers, they will be indexed.
	// INPUT: Player message with these fields populated:
	//  - id
	//  - properties
	// OUTPUT: Result message denoting success or failure (and an error if
	// necessary)
	CreatePlayer(context.Context, *Player) (*Result, error)
	// DeletePlayer removes the player from state storage by doing the
	// following:
	//  1) Delete player from configured indices.  This effectively removes the
	//     player from matchmaking when using recommended MMF patterns.
	//     Everything after this is just cleanup to save stage storage space.
	//  2) 'Lazily' delete the player's state storage record.  This is kicked
	//     off in the background and may take some time to complete.
	//  2) 'Lazily' delete the player's metadata indicies (like, the timestamp when
	//     they called CreatePlayer, and the last time the record was accessed).  This
	//     is also kicked off in the background and may take some time to complete.
	// INPUT: Player message with the 'id' field populated.
	// OUTPUT: Result message denoting success or failure (and an error if
	// necessary)
	DeletePlayer(context.Context, *Player) (*Result, error)
	// GetUpdates streams matchmaking results from Open Match for the
	// provided player ID.
	// INPUT: Player message with the 'id' field populated.
	// OUTPUT: a stream of player objects with one or more of the following
	// fields populated, if an update to that field is seen in state storage:
	//  - 'assignment': string that usually contains game server connection information.
	//  - 'status': string to communicate current matchmaking status to the client.
	//  - 'error': string to pass along error information to the client.
	//
	// During normal operation, the expectation is that the 'assignment' field
	// will be updated by a Backend process calling the 'CreateAssignments' Backend API
	// endpoint.  'Status' and 'Error' are free for developers to use as they see fit.
	// Even if you had multiple players enter a matchmaking request as a group, the
	// Backend API 'CreateAssignments' call will write the results to state
	// storage separately under each player's ID. OM expects you to make all game
	// clients 'GetUpdates' with their own ID from the Frontend API to get
	// their results.
	//
	// NOTE: This call generates a small amount of load on the Frontend API and state
	//  storage while watching the player record for updates. You are expected
	//  to close the stream from your client after receiving your matchmaking
	//  results (or a reasonable timeout), or you will continue to
	//  generate load on OM until you do!
	// NOTE: Just bear in mind that every update will send egress traffic from
	//  Open Match to game clients! Frugality is recommended.
	GetUpdates(*Player, Frontend_GetUpdatesServer) error
}

func RegisterFrontendServer(s *grpc.Server, srv FrontendServer) {
	s.RegisterService(&_Frontend_serviceDesc, srv)
}

func _Frontend_CreatePlayer_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Player)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(FrontendServer).CreatePlayer(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/api.Frontend/CreatePlayer",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(FrontendServer).CreatePlayer(ctx, req.(*Player))
	}
	return interceptor(ctx, in, info, handler)
}

func _Frontend_DeletePlayer_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Player)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(FrontendServer).DeletePlayer(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/api.Frontend/DeletePlayer",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(FrontendServer).DeletePlayer(ctx, req.(*Player))
	}
	return interceptor(ctx, in, info, handler)
}

func _Frontend_GetUpdates_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(Player)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(FrontendServer).GetUpdates(m, &frontendGetUpdatesServer{stream})
}

type Frontend_GetUpdatesServer interface {
	Send(*Player) error
	grpc.ServerStream
}

type frontendGetUpdatesServer struct {
	grpc.ServerStream
}

func (x *frontendGetUpdatesServer) Send(m *Player) error {
	return x.ServerStream.SendMsg(m)
}

var _Frontend_serviceDesc = grpc.ServiceDesc{
	ServiceName: "api.Frontend",
	HandlerType: (*FrontendServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "CreatePlayer",
			Handler:    _Frontend_CreatePlayer_Handler,
		},
		{
			MethodName: "DeletePlayer",
			Handler:    _Frontend_DeletePlayer_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "GetUpdates",
			Handler:       _Frontend_GetUpdates_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "api/protobuf-spec/frontend.proto",
}

func init() { proto.RegisterFile("api/protobuf-spec/frontend.proto", fileDescriptor1) }

var fileDescriptor1 = []byte{
	// 201 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x94, 0xcf, 0x3d, 0x6b, 0xc3, 0x30,
	0x10, 0xc6, 0x71, 0x9b, 0x42, 0x29, 0xa2, 0x43, 0xf1, 0xe8, 0xa9, 0x78, 0xb7, 0x55, 0xfa, 0x42,
	0xf7, 0xba, 0xd4, 0xab, 0x29, 0x74, 0xe9, 0x76, 0xb2, 0xcf, 0xb6, 0x40, 0xd2, 0x09, 0xe9, 0x34,
	0xf4, 0x3b, 0xf5, 0x43, 0x86, 0xd8, 0x21, 0x64, 0x08, 0x81, 0xac, 0x7f, 0x9e, 0xdf, 0xf0, 0x88,
	0x47, 0xf0, 0x5a, 0xfa, 0x40, 0x4c, 0x2a, 0x4d, 0x75, 0xf4, 0x38, 0xc8, 0x29, 0x90, 0x63, 0x74,
	0x63, 0xb3, 0xe6, 0xe2, 0x06, 0xbc, 0x2e, 0xcf, 0xcc, 0x2c, 0xc6, 0x08, 0x33, 0xc6, 0x6d, 0xf6,
	0xfc, 0x9f, 0x8b, 0xbb, 0xaf, 0x83, 0x2c, 0x5e, 0xc5, 0x7d, 0x1b, 0x10, 0x18, 0x7b, 0x03, 0x7f,
	0x18, 0x8a, 0x87, 0xe6, 0xb8, 0xde, 0x4a, 0x79, 0x52, 0xbe, 0x31, 0x26, 0xc3, 0x55, 0xb6, 0x57,
	0x9f, 0x68, 0xf0, 0x6a, 0x25, 0x3a, 0xe4, 0x1f, 0x3f, 0x02, 0x63, 0xbc, 0x6c, 0xb6, 0x52, 0x65,
	0x4f, 0xf9, 0xc7, 0xfb, 0xef, 0xdb, 0xac, 0x79, 0x49, 0xaa, 0x19, 0xc8, 0xca, 0x8e, 0x68, 0x36,
	0xd8, 0x1a, 0x4a, 0x63, 0x6f, 0x80, 0x27, 0x0a, 0x56, 0x92, 0x47, 0x57, 0x5b, 0xe0, 0x61, 0x91,
	0xda, 0x31, 0x06, 0x07, 0x46, 0x7a, 0xa5, 0x6e, 0xd7, 0xbb, 0x2f, 0xbb, 0x00, 0x00, 0x00, 0xff,
	0xff, 0xe8, 0x9b, 0x69, 0x06, 0x39, 0x01, 0x00, 0x00,
}
